//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//	elo|rxrsdl@풓^elhCo
//			DLL Import Header
//			Windows Converted by C60
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

#ifndef WINFMPIMPORT_H
#define WINFMPIMPORT_H

#include	<windows.h>
#include	<stdlib.h>

typedef unsigned char uchar;
typedef unsigned short ushort;
typedef unsigned int uint;
typedef unsigned long ulong;
typedef unsigned char BYTE;
typedef unsigned short WORD;
typedef unsigned long DWORD;


//=============================================================================
//	o[W
//=============================================================================
#define	FMP_InterfaceVersion		001		// PFmajor, QFminor version


//=============================================================================
//	DLL ̖߂l
//=============================================================================
#define	WINFMP_OK				 		  0		// I
#define	FMP_ERR_OPEN_MUSIC_FILE			  1		//  f[^JȂ
#define	FMP_ERR_WRONG_MUSIC_FILE		  2		// FMP ̋ȃf[^ł͂Ȃ
#define	FMP_ERR_OPEN_PVI_FILE		 	  3		// PVI JȂ
#define	FMP_ERR_OPEN_PPZ1_FILE		 	  6		// PPZ1 JȂ
#define	FMP_ERR_WRONG_PVI_FILE		 	  8		// PVI ł͂Ȃ
#define	FMP_ERR_WRONG_PPZ1_FILE		 	 11		// PVI ł͂Ȃ(PPZ1)
#define	FMP_WERNING_PVI_ALREADY_LOAD	 13		// PVI ͂łɓǂݍ܂Ă
#define	FMP_WERNING_PPZ1_ALREADY_LOAD	 16		// PPZ1 ͂łɓǂݍ܂Ă

#define	FMP_ERR_WRONG_PARTNO			 30		// p[gԍsK
//#define	FMP_ERR_ALREADY_MASKED			 31		// wp[g͂łɃ}XNĂ
#define	FMP_ERR_NOT_MASKED				 32		// wp[g̓}XNĂȂ
#define	FMP_ERR_MUSIC_STOPPED			 33		// Ȃ~܂Ă̂Ƀ}XN

#define	FMP_ERR_OUT_OF_MEMORY			 99		// mۂłȂ


//----------------------------------------------------------------------------
//	vhmelop̒`
//----------------------------------------------------------------------------
#define	SOUND_55K					  55555
#define	SOUND_44K					  44100
#define	SOUND_22K					  22050
#define	SOUND_11K					  11025

#define	FMP_MAX_PCMDIR					 64


//----------------------------------------------------------------------------
//	̑`
//----------------------------------------------------------------------------
#define	FMP_MUSDATASIZE				  65536		// őȃf[^TCY
#define	FMP_COMMENTDATASIZE	 		   8192		// őRsRgTCY

#define	FMP_NumOfFMPart				     6
#define	FMP_NumOfSSGPart				 3
#define	FMP_NumOfADPCMPart				 1
#define	FMP_NumOFOPNARhythmPart			 1
#define	FMP_NumOfExtPart				 3
#define	FMP_NumOfPPZ8Part			     8
#define	FMP_NumOfAllPart	(FMP_NumOfFMPart+FMP_NumOfSSGPart+FMP_NumOfADPCMPart+FMP_NumOFOPNARhythmPart+FMP_NumOfExtPart+FMP_NumOfPPZ8Part)



//----------------------------------------------------------------------------
//	eloeԕێ
//
//            fedcba98 76543210
// FMP_sysbit xxxxxxxx xxxxxxxx
//            |||||||| |||||||+---@
//            |||||||| ||||||+----@
//            |||||||| |||||+-----@
//            |||||||| ||||+------@
//            |||||||| |||+-------@
//            |||||||| ||+--------@
//            |||||||| |+---------@ooyWt
//            |||||||| +----------@
//            ||||||||
//            |||||||+------------@
//            ||||||+-------------@
//            |||||+--------------@
//            ||||+---------------@
//            |||+----------------@
//            ||+-----------------@tF[hAEg
//            |+------------------@[v
//            +-------------------@t~
//
//----------------------------------------------------------------------------

#define	FMP_SYS_PPZ8USE		0x0040		// ooyWt@Cgp
#define	FMP_SYS_FADE		0x2000		// tF[hAEg
#define	FMP_SYS_LOOP		0x4000		// [v
#define	FMP_SYS_STOP		0x8000		// t~
#define	FMP_SYS_INIT		FMP_SYS_STOP


//----------------------------------------------------------------------------
//	obl`tO
//----------------------------------------------------------------------------
#define	FMP_PCM_USEV1		0x0001		// ouhPgp
#define	FMP_PCM_USEZ1		0x0010		// ooyPgp


//============================================================================
//	ken[N\̒`
//============================================================================
//----------------------------------------------------------------------------
//	ru[g[N\
//----------------------------------------------------------------------------
typedef struct lfostag
{
	int		LfoSdelay		; // ru[g fBCl
	int		LfoSspeed		; // ru[g Xs[h
	int		LfoScnt_dly		; // ru[g fBCJE^
	int		LfoScnt_spd		; // ru[g Xs[hJE^
	int		LfoSdepth		; // ru[g 炵JEgl
	int		LfoScnt_dep		; // ru[g 炵JE^
	int		LfoSrate1		; // ru[g l
	int		LfoSrate2		; // ru[g liTuj
	int		LfoSwave		; // ru[g g`
} LFOS;

#define	S_LFOS		sizeof(LFOS)


//----------------------------------------------------------------------------
//	g[N\
//----------------------------------------------------------------------------
typedef struct alfostag
{
	int		AlfoSdelay		; // g fBCl
	int		AlfoSspeed		; // g Xs[h
	int		AlfoScnt_dly	; // g fBCJE^
	int		AlfoScnt_spd	; // g Xs[h
	int		AlfoSdepth		; // g ω
	int		AlfoScnt_dep	; // g ωʃJE^
	int		AlfoSrate		; // g l
	int		AlfoSrate_org	; // g l
} ALFOS;

#define	S_ALFOS		sizeof(ALFOS)


//----------------------------------------------------------------------------
//	EE[N\
//----------------------------------------------------------------------------
typedef struct wlfostag
{
	int		WlfoSdelay		; // EE fBCl
	int		WlfoSspeed		; // EE Xs[h
	int		WlfoScnt_dly	; // EE fBCJE^
	int		WlfoScnt_spd	; // EE Xs[hJE^
	int		WlfoSdepth		; // EE ω
	int		WlfoScnt_dep	; // EE ωʃJE^
	int		WlfoSrate		; // EE l
	int		WlfoSrate_org	; // EE ݂̂炵l
	int		WlfoSrate_now	; // EE ݂̂炵l
	int		WlfoSsync		; // EE VN^}XN
} WLFOS;

#define	S_WLFOS		sizeof(WLFOS)

#define	FMP_WLFO_SYNC	0x80	// VNrbg
								// ʂSrbgXbg}XN


//============================================================================
//	sb`xh[N\̒`
//============================================================================
typedef struct pitstag
{
	int		PitSdat			; // sb`xhωl
	int		PitSdelay		; // fBCl
	int		PitSspeed		; // Xs[h
	int		PitScnt			; // Xs[hJE^
	int		PitSwave		; // ڕWg
	int		PitStarget		; // ڕWK
} PITS;

#define	S_PITS		sizeof(PITS)


//----------------------------------------------------------------------------
//	rrfGx[v[N\
//----------------------------------------------------------------------------
typedef struct envstag
{
	int		EnvSsv			; // X^[gH[
	int		EnvSar			; // A^bN[g
	int		EnvSdr			; // fBPC[g
	int		EnvSsl			; // TXeBx
	int		EnvSsr			; // TXeB[g
	int		EnvSrr			; // [X[g
} ENVS;

#define	S_ENVS		sizeof(ENVS)


//============================================================================
//	p[g[N\̒`
//============================================================================
typedef struct cpatstag
{
	int		PartSlfo_f		; // kenԃtO
	int		PartSdeflen		; // ftHg̉

	int		PartSvol		; // ݂̉
	int		PartSdat_q		; // Q[grl

	int		PartScnt		; // JE^
	int		PartSorg_q		; // Q[gpJE^

	int		PartStmpvol		; // ۂ̏o͉
	int		PartSdat_k		; // jx点l

	int		PartScnt_k		; // jx点pJE^
	int		PartSbefore		; // PỎ

	int		PartSstatus		; // ԃtO
	int		PartSsync		; // VNtO

	int		PartSdetune		; // f`[l
	PITS	PartSpitch		; // sb`xhp[N
	LFOS	PartSlfo[3]		; // ru[gkeniOCPCQj
	int		PartSwave		; // ۂ̏o͎g
	
	int		PartSwave2		; // PȌo͎g

	int		PartSxtrns		; // K̂p
	int		PartStone		; // ݂̉Fԍ

	int		PartSkeyon		; // Oj擾p

	int		PartSpan		; // p擾p
	int		PartSalg		; // ݂̃ASYԍ

	int		PartSio			; // o͂h^nAhX
	uchar	*PartSpoint		; // ǂݍ݃|C^
	uchar	*PartSloop		; // Ԃ|C^
	int		PartSchan		; // `lʗp
	int		PartSbit		; // `lbit
	int		PartSport		; // elAhXANZXp
} CPATS;


//----------------------------------------------------------------------------
//	elp[g[N\
//----------------------------------------------------------------------------
typedef struct fpatstag
{
	uchar	*FpatSaddr		; // skAhX
	ALFOS	FpatSalfo		; // gp[N
	WLFOS	FpatSwlfo		; // EEp[N
	int		FpatS_hdly		; // gkenfBC
	int		FpatS_hdlycnt	; // gkenJE^
	int		FpatS_hfreq		; // gken@
	int		FpatS_hapms		; // gken@olr^`lr
	int		FpatSextend		; // extend[h
	int		FpatSslot_v[4]	; // XbgƂ̑Βl
} FPATS;


//----------------------------------------------------------------------------
//	rrfp[g[N\
//----------------------------------------------------------------------------
typedef struct spatstag
{
	int		SpatSnow_vol	; // ݂̉
	int		SpatSflg		; // GF[vԃtO
	int		SpatSoct		; // IN^[u
	int		SpatSvol		; // ݂̏o͉
	ENVS	SpatSenv		; // \tgEFAGx[v
	ENVS	*SpatSenvadr	; // SSG Env pattern Address
} SPATS;


//----------------------------------------------------------------------------
//	`coblp[g[N\
//----------------------------------------------------------------------------
typedef struct apatstag
{
	int		ApatSstart		; // obl X^[gAhX
	int		ApatSend		; // obl GhAhX
	int		ApatSdelta		; // obl ml
} APATS;

#define	S_APATS		sizeof(APATS)


//----------------------------------------------------------------------------
//	p[g[N\
//----------------------------------------------------------------------------
typedef struct patstag
{
	CPATS	CPatS			; // ʃ[N
	union {
		FPATS	FPatS		; // elp[g[N\
		SPATS	SPatS		; // rrfp[g[N\
		APATS	APatS		; // `coblp[g[N\
	} EPatS;
} PARTS;

#define	S_PARTS		sizeof(PARTS)


//----------------------------------------------------------------------------
//	tF[hAEgf[^\
//----------------------------------------------------------------------------
typedef struct fadestag
{
	int		FadeSfm			;
	int		FadeSssg		;
	int		FadeSrhy		;
	int		FadeSapcm		;
} FADES;

#define	S_FADES		sizeof(FADES)


//----------------------------------------------------------------------------
//	O[N\
//----------------------------------------------------------------------------
typedef struct syncstag
{
	int		SyncSdat		; // f[^
	int		SyncScnt		; // JEg
} SYNCS;

#define	S_SYNCS		sizeof(SYNCS)


//----------------------------------------------------------------------------
//	elo[N\
//----------------------------------------------------------------------------
typedef struct fmpstag
{
	int		FmpStempo		; // 00 ݂̃e|
	SYNCS	FmpSsync		; // 01 Of[^
	int		FmpSsysbit		; // 0a eloXe[^X
	int		FmpScnt_c		; // 0c ȉtNbN
	int		FmpScnt_t		; // 0e ҂JE^
	FADES	FmpSfade		; // 0f tF[hAEg
	FADES	FmpSfade_o		; // 13 tF[hAEgʁiIWij
	int		FmpSloop_c		; // 14 ȃ[v
	int		FmpStempo_t		; // 17 ݂̃e|i\j
	int		FmpSmix_s		; // 18 ??FEDFED
	int		FmpStimer		; // 19 ^C}[[hl
	int		FmpSnoise		; // 1a rrf̃mCYg
	int		FmpSsho			; // 1b ߃JE^
	int		FmpSpcmuse		; // 1d oblgp
	int		FmpScnt_ct		; // 1f ȑS̃JEg
	int		FmpScnt_cl		; // 23 ȃ[vJEg
	int		FmpSmix_e		; // 29 ʉmixer
	int		FmpStempo_e		; // 2a ʉ̃ftHge|
} FMPS;

#define	S_FMPS		sizeof(FMPS)


//----------------------------------------------------------------------------
//	S̃[N
//----------------------------------------------------------------------------
typedef struct workstag
{
	FMPS	ExtBuff;				// OQƋ[N
	PARTS	_F[FMP_NumOfFMPart];	// el[N
	PARTS	_A;						// `cobl[N
	PARTS	_X[FMP_NumOfExtPart];	// elextend[N
	PARTS	_P[FMP_NumOfPPZ8Part];	// obl(ppz8)[N
	PARTS	_S[FMP_NumOfSSGPart];	// rrf[N
	
	//------------------------------------------------------------------------
	//	Y[N
	//------------------------------------------------------------------------
	int		R_key[16];				// ΂ɕςȂ
	int		R_mask;
	int		R_Oncho_cnt;
	int		R_Oncho_def;
	int		RTL_vol;
	int		R_vol[6];
	int		R_pan[6];
	int		R_Loop_now;
	int		R_Sync_flg;
	int		R_State_flg;			// Cl[utO
	PARTS	_R;

	//------------------------------------------------------------------------
	//	f[^[N
	//------------------------------------------------------------------------
	int		TotalLoop;				// [vIJE^
	int		Loop_cnt;				// [vI
	int		Int_fcT;				// 荞݃tF[hJE^
	int		Int_fc;					// 荞݃tF[hJE^
	int		TimerA_cnt;				// sfBC
	int		Ver;					// ȃf[^o[W
	int		NowPPZmode;				// ݂̂ooy̍Đ[h
	int		MusicClockCnt;			// Ȃ̃NbNJEg(C??)
	int		ClockCnt;				// NbNJEg
	int		PcmHardVol;				// obln[h
	int		ExtendKeyon;			// extendԂ3chkeyon
	int		ExtendAlg;				// extend`l̃ASY

	//------------------------------------------------------------------------
	//	f[^[N
	//------------------------------------------------------------------------
	int		FM_effect_dat[4];		// ʉ[h炵l
	int		Play_flg;				// ttO
	int		Loop_flg;				// [vtO
	int		Int_CX;					// 荞݃tF[hJE^
	
	//------------------------------------------------------------------------
	//	`lʃ[NAhXe[u
	//------------------------------------------------------------------------
	PARTS	*Chan_tbl_R;					// Y
	PARTS	*Chan_tbl[FMP_NumOfFMPart+FMP_NumOfSSGPart+FMP_NumOfPPZ8Part+1+FMP_NumOfExtPart+1];

	//------------------------------------------------------------------------
	//	rrfGx[v[N
	//------------------------------------------------------------------------
	ENVS	EnvAddr[FMP_NumOfSSGPart];
	
	//------------------------------------------------------------------------
	//	t̋Ȃ̃t@C
	//------------------------------------------------------------------------
	char	Music_name[_MAX_PATH];	// t̋Ȃ̃t@C

	//------------------------------------------------------------------------
	//	݂̂ouht@C
	//------------------------------------------------------------------------
	char	PVI_name[_MAX_PATH];	// ݂̂oblt@C
	
	//------------------------------------------------------------------------
	//	vhmelopf[^
	//------------------------------------------------------------------------
	int		rate;				//	PCM o͎g(11k, 22k, 44k, 55k)
	bool	ppz8ip;								// PPZ8 ŕ⊮邩
	int		fadeout2_speed;						// fadeout()speed(>0 fadeout)
	int		lastSyncExtTime;					// Ō Sync_Ext s(ms/JIPpj
	char	pcmdir[FMP_MAX_PCMDIR+1][_MAX_PATH];	//	PCM fBNg
} WORKS;

#define	S_WORKS			sizeof(WORKS)



//=============================================================================
//	WinFMP API
//=============================================================================
#ifdef __cplusplus
extern "C" {
#endif

__declspec(dllimport) int WINAPI fmp_getversion(void);
__declspec(dllimport) int WINAPI fmp_getinterfaceversion(void);
__declspec(dllimport) bool WINAPI fmp_init(char *path);
__declspec(dllimport) int WINAPI fmp_load(char *filename);
__declspec(dllimport) int WINAPI fmp_load2(uchar *musdata, int size);
__declspec(dllimport) void WINAPI fmp_start(void);
__declspec(dllimport) int WINAPI fmp_stop(void);
__declspec(dllimport) void WINAPI fmp_getpcmdata(short *buf, int nsamples);
__declspec(dllimport) int WINAPI fmp_maskon(bool rhythm_flag, int ah);
__declspec(dllimport) int WINAPI fmp_maskoff(bool rhythm_flag, int ah);
__declspec(dllimport) bool WINAPI fmp_loadrhythmsample(char *path);
__declspec(dllimport) bool WINAPI fmp_setpcmdir(char **path);
__declspec(dllimport) void WINAPI fmp_setpcmrate(int rate);
__declspec(dllimport) void WINAPI fmp_fadeout(int speed);
__declspec(dllimport) void WINAPI fmp_fadeout2(int speed);
__declspec(dllimport) void WINAPI fmp_setppzinterpolation(bool ip);
__declspec(dllimport) char * WINAPI fmp_getcomment(char *dest, uchar *musdata, int size);
__declspec(dllimport) char * WINAPI fmp_getcomment2(char *dest, uchar *musdata, int size);
__declspec(dllimport) char ** WINAPI fmp_getcomment3(char *dest[], uchar *musdata, int size);
__declspec(dllimport) int WINAPI fmp_fgetcomment(char *dest, char *filename);
__declspec(dllimport) int WINAPI fmp_fgetcomment2(char *dest, char *filename);
__declspec(dllimport) int WINAPI fmp_fgetcomment3(char *dest[], char *filename);
__declspec(dllimport) char * WINAPI fmp_getdefinedpcmfilename(char *dest, uchar *musdata, int size);
__declspec(dllimport) char * WINAPI fmp_getdefinedppzfilename(char *dest, uchar *musdata, int size, int bufnum);
__declspec(dllimport) int WINAPI fmp_fgetdefinedpcmfilename(char *dest, char *filename);
__declspec(dllimport) int WINAPI fmp_fgetdefinedppzfilename(char *dest, char *filename, int bufnum);
__declspec(dllimport) char * WINAPI fmp_getmusicfilename(char *dest);
__declspec(dllimport) char * WINAPI fmp_getpcmfilename(char *dest);
__declspec(dllimport) char * WINAPI fmp_getppzfilename(char *dest, int bufnum);
__declspec(dllimport) void WINAPI fmp_setfmvoldown(int voldown);
__declspec(dllimport) void WINAPI fmp_setssgvoldown(int voldown);
__declspec(dllimport) void WINAPI fmp_setrhythmvoldown(int voldown);
__declspec(dllimport) void WINAPI fmp_setadpcmvoldown(int voldown);
__declspec(dllimport) void WINAPI fmp_setppzvoldown(int voldown);
__declspec(dllimport) int WINAPI fmp_getfmvoldown(void);
__declspec(dllimport) int WINAPI fmp_getssgvoldown(void);
__declspec(dllimport) int WINAPI fmp_getrhythmvoldown(void);
__declspec(dllimport) int WINAPI fmp_getadpcmvoldown(void);
__declspec(dllimport) int WINAPI fmp_getppzvoldown(void);
__declspec(dllimport) void WINAPI fmp_setpos(int pos);
__declspec(dllimport) void WINAPI fmp_setpos2(int pos);
__declspec(dllimport) int WINAPI fmp_getpos(void);
__declspec(dllimport) int WINAPI fmp_getpos2(void);
__declspec(dllimport) bool WINAPI fmp_getlength(char *filename, int *length, int *loop);
__declspec(dllimport) bool WINAPI fmp_getlength2(char *filename, int *length, int *loop);
__declspec(dllimport) int WINAPI fmp_getloopcount(void);
__declspec(dllimport) WORKS * WINAPI fmp_getworks(void);


#ifdef __cplusplus
}
#endif


#endif // WINFMPIMPORT_H
